import axios from 'axios';
import { API_URL_HOME } from '@/shared/api/api-url-home';
import { resultify } from '@/shared/lib/resultify';
import { NiceAxiosError } from '@/shared/@types/error';
import { 
  HomeGroupsParams,
  HomeGroupsResponse
} from '../model/types';
import { 
  useMutation,
  UseMutationOptions
} from '@tanstack/react-query';
import { getHeaderUserAgent } from '@/shared/constants/url';

export const homeGroups = (params: HomeGroupsParams) => {
  let headerOptions = {
    menuId: 0,
    apiType: 'SELECT'
  };
  let options = {
    headers: {
      'X-User-Agent': getHeaderUserAgent(headerOptions)
    }
  };
  return resultify(
    axios.post<HomeGroupsResponse>(API_URL_HOME.homeGroups(), params, options),
  );
};

export const useHomeGroupsMutation = (options?: UseMutationOptions<HomeGroupsResponse, NiceAxiosError, HomeGroupsParams>) => {
  const mutation = useMutation<HomeGroupsResponse, NiceAxiosError, HomeGroupsParams>({
    ...options,
    mutationFn: (params: HomeGroupsParams) => homeGroups(params),
  });

  return {
    ...mutation,
  };
};
